<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Картриджи</title>
  </head>

  <body>
    <div class="container">
      <div class="item-container">
        <h4>Картриджи на отправку:</h4>

        <button id="reset-btn" class="reset-button">Очистить</button>
      </div>

      <div class="item-container">
        <button class="button-primary minus" data-id="05A">-</button>
        <span>05A</span>
        <button class="button-primary plus" data-id="05A">+</button
        ><span class="sign">=</span>
        <span class="result" id="05A">0</span>
      </div>

      <div class="item-container">
        <button class="button-primary minus" data-id="05X">-</button>
        <span>05X</span>
        <button class="button-primary plus" data-id="05X">+</button
        ><span class="sign">=</span>
        <span class="result" id="05X">0</span>
      </div>

      <div class="item-container">
        <button class="button-primary minus" data-id="37A">-</button>
        <span>37A</span>
        <button class="button-primary plus" data-id="37A">+</button
        ><span class="sign">=</span>
        <span class="result" id="37A">0</span>
      </div>

      <div class="item-container">
        <button class="button-primary minus" data-id="37Y">-</button>
        <span>37Y</span>
        <button class="button-primary plus" data-id="37Y">+</button
        ><span class="sign">=</span>
        <span class="result" id="37Y">0</span>
      </div>

      <div class="item-container">
        <button class="button-primary minus" data-id="64A">-</button>
        <span>64A</span>
        <button class="button-primary plus" data-id="64A">+</button
        ><span class="sign">=</span>
        <span class="result" id="64A">0</span>
      </div>

      <div class="item-container">
        <button class="button-primary minus" data-id="64X">-</button>
        <span>64X</span>
        <button class="button-primary plus" data-id="64X">+</button
        ><span class="sign">=</span>
        <span class="result" id="64X">0</span>
      </div>

      <div class="item-container">
        <button class="button-primary minus" data-id="30A">-</button>
        <span>30A</span>
        <button class="button-primary plus" data-id="30A">+</button
        ><span class="sign">=</span>
        <span class="result" id="30A">0</span>
      </div>

      <div class="item-container">
        <button class="button-primary minus" data-id="30X">-</button>
        <span>30X</span>
        <button class="button-primary plus" data-id="30X">+</button
        ><span class="sign">=</span>
        <span class="result" id="30X">0</span>
      </div>

      <div class="item-container">
        <button class="button-primary minus" data-id="26A">-</button>
        <span>26A</span>
        <button class="button-primary plus" data-id="26A">+</button
        ><span class="sign">=</span>
        <span class="result" id="26A">0</span>
      </div>

      <div class="item-container">
        <button class="button-primary minus" data-id="26X">-</button>
        <span>26X</span>
        <button class="button-primary plus" data-id="26X">+</button
        ><span class="sign">=</span>
        <span class="result" id="26X">0</span>
      </div>

      <div class="item-container">
        <button class="button-primary minus" data-id="49A">-</button>
        <span>49A</span>
        <button class="button-primary plus" data-id="49A">+</button
        ><span class="sign">=</span>
        <span class="result" id="49A">0</span>
      </div>

      <div class="item-container">
        <button class="button-primary minus" data-id="53A">-</button>
        <span>53A</span>
        <button class="button-primary plus" data-id="53A">+</button
        ><span class="sign">=</span>
        <span class="result" id="53A">0</span>
      </div>

      <div class="item-container">
        <button class="button-primary minus" data-id="83A">-</button>
        <span>83A</span>
        <button class="button-primary plus" data-id="83A">+</button
        ><span class="sign">=</span>
        <span class="result" id="83A">0</span>
      </div>

      <div class="item-container">
        <button class="button-primary minus" data-id="83X">-</button>
        <span>83X</span>
        <button class="button-primary plus" data-id="83X">+</button
        ><span class="sign">=</span>
        <span class="result" id="83X">0</span>
      </div>
      
      <div class="item-container">
        <button class="button-primary minus" data-id="85A">-</button>
        <span>85A</span>
        <button class="button-primary plus" data-id="85A">+</button
        ><span class="sign">=</span>
        <span class="result" id="85A">0</span>
      </div>

      <div class="item-container">
        <button class="button-primary minus" data-id="85X">-</button>
        <span>85X</span>
        <button class="button-primary plus" data-id="85X">+</button
        ><span class="sign">=</span>
        <span class="result" id="85X">0</span>
      </div>

      <div class="item-container">
        <button class="button-primary minus" data-id="78A">-</button>
        <span>78A</span>
        <button class="button-primary plus" data-id="78A">+</button
        ><span class="sign">=</span>
        <span class="result" id="78A">0</span>
      </div>

      <div class="item-container">
        <button class="button-primary minus" data-id="78X">-</button>
        <span>78X</span>
        <button class="button-primary plus" data-id="78X">+</button
        ><span class="sign">=</span>
        <span class="result" id="78X">0</span>
      </div>

      <div class="item-container">
        <button class="button-primary minus" data-id="87A">-</button>
        <span>87A</span>
        <button class="button-primary plus" data-id="87A">+</button
        ><span class="sign">=</span>
        <span class="result" id="87A">0</span>
      </div>

      <div class="item-container">
        <button class="button-primary minus" data-id="87X">-</button>
        <span>87X</span>
        <button class="button-primary plus" data-id="87X">+</button
        ><span class="sign">=</span>
        <span class="result" id="87X">0</span>
      </div>

      <div class="item-container">
        <button class="button-primary minus" data-id="12A">-</button>
        <span>12A</span>
        <button class="button-primary plus" data-id="12A">+</button
        ><span class="sign">=</span>
        <span class="result" id="12A">0</span>
      </div>

      <div class="item-container">
        <button class="button-primary minus" data-id="15A">-</button>
        <span>15A</span>
        <button class="button-primary plus" data-id="15A">+</button
        ><span class="sign">=</span>
        <span class="result" id="15A">0</span>
      </div>

      <button id="copy-text-btn" class="copy-button">Копировать</button>
    </div>
    <style>
      .container {
        margin: auto;
        max-width: 320px;
        display: grid;
        gap: 10px;
        font-size: 1.3em;
        font-weight: bold;
        font-family: sans-serif;
      }
      .item-container {
        display: flex;
        justify-content: space-between;
        align-content: center;
        align-items: center;
      }
      .minus,
      .plus,
      .copy-button,
      .reset-button {
        font-size: 1.3em;
        border-radius: 8px;
        font-family: sans-serif;
        border-color: #fff;
      }
      .minus,
      .plus {
        width: 2em;
        color: #fff;
      }
      .plus {
        background-color: green;
      }
      .minus {
        background-color: tomato;
      }
      .result {
        font-size: 1.5em;
        color: darkolivegreen;
      }
    </style>
    <script>
      // создание объекта картриджи
      let cart = {
        '05A': {
          name: '05A',
          count: 0,
        },
        '05X': {
          name: '05X',
          count: 0,
        },
        '37A': {
          name: '37A',
          count: 0,
        },
        '37Y': {
          name: '37Y',
          count: 0,
        },
        '64A': {
          name: '64A',
          count: 0,
        },
        '64X': {
          name: '64X',
          count: 0,
        },
        '30A': {
          name: '30A',
          count: 0,
        },
        '30X': {
          name: '30X',
          count: 0,
        },
        '26A': {
          name: '26A',
          count: 0,
        },
        '26X': {
          name: '26X',
          count: 0,
        },
        '49A': {
          name: '49A',
          count: 0,
        },
        '53A': {
          name: '53A',
          count: 0,
        },
        '83A': {
          name: '83A',
          count: 0,
        },
        '83X': {
          name: '83X',
          count: 0,
          },
        '85A': {
          name: '85A',
          count: 0,
        },
        '85X': {
          name: '85X',
          count: 0,
        },
        '78A': {
          name: '78A',
          count: 0,
        },
        '78X': {
          name: '78X',
          count: 0,
        },
        '87A': {
          name: '87A',
          count: 0,
        },
        '87X': {
          name: '87X',
          count: 0,
        },
        '12A': {
          name: '12A',
          count: 0,
        },
        '15A': {
          name: '15A',
          count: 0,
        },
      };
      // включение прослушки кнопок
      document.onclick = (event) => {
        if (event.target.classList.contains('plus')) {
          plusFunction(event.target.dataset.id);
        }
        if (event.target.classList.contains('minus')) {
          minusFunction(event.target.dataset.id);
        }
      };
      // увеличение количества картриджей
      const plusFunction = (id) => {
        cart[id].count++;
        renderCart();
      };

      // уменьшение количества картриджей
      const minusFunction = (id) => {
        if (cart[id]['count'] === 0) {
          // deleteFunction(id);
          return true;
        }
        cart[id]['count']--;
        renderCart();
      };

      // вывод результатов
      const renderCart = () => {
        writeLocalStorage();
        for (let key in cart) {
          document.getElementById(key).innerText = cart[key].count;
        }
      };

      // копирование результата в буфер обмена
      function copyText() {
        let elementText = '';
        for (let key in cart) {
          if (cart[key].count > 0) {
            elementText += `${cart[key].name} = ${cart[key].count} шт;\n`;
          }
        }
        console.log(elementText);
        let inputElement = document.createElement('textarea');
        inputElement.value = elementText;
        document.body.appendChild(inputElement);
        inputElement.select();
        document.execCommand('copy');
        inputElement.parentNode.removeChild(inputElement);
      }
      function resetCart() {
        for (let key in cart) {
          cart[key].count = 0;
        }
        writeLocalStorage();
      }
      function readLocalStorage() {
        const json = localStorage.getItem('cartridge_project');
        if (json) {
          cart = JSON.parse(json);
        }
      }
      function writeLocalStorage() {
        localStorage.setItem('cartridge_project', JSON.stringify(cart));
      }
      document.querySelector('#copy-text-btn').onclick = function () {
        copyText();
      };
      document.querySelector('#reset-btn').onclick = function () {
        resetCart();
        renderCart();
      };
      readLocalStorage();
      renderCart();
    </script>
  </body>
</html>
